`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    13:11:48 06/13/2011 
// Design Name: 
// Module Name:    Circle 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module circle( clk,
					start,
					center_x,
					center_y,
					radius,
					deg,
					plot_ready,
					plot_start,
					x_out,
					y_out,
					ready
					
    );

input				clk;
input				start;
input	[8:0]		center_x;
input [7:0]		center_y;
input [7:0]		radius;
input [7:0]		deg;
input				plot_ready;

output			plot_start;
reg				plot_start	= 0;
output [8:0]	x_out;
reg	 [8:0]	x_out;
output [7:0]	y_out;
reg	 [7:0]	y_out;
output			ready;
 
reg				busy = 0; 
reg	 [4:0]	circle_cikl	 = 0;
reg	 [10:0]	H				 = 0;
reg	 [8:0]	x				 = 0;
reg	 [7:0]	y				 = 0;
reg				carry_x		 = 0;
reg				carry_y		 = 0;
reg				plot			 = 0;
wire				pixel_ready;

assign	ready 		= !start && !busy;
assign	pixel_ready	= plot_ready && !plot_start && !plot; 

always @ ( posedge clk ) begin 

   if( start == 1 && busy == 0 ) begin 
		busy 			<= 1;
		circle_cikl	<= 0;
	end

	plot_start <= 0;
	
	if ( busy == 1 ) begin 
		if ( plot == 1 && carry_x == 0 && carry_y == 0 ) begin	
			plot_start 	<= 1;
			plot 			<= 0;
		end
		else begin
			plot			<= 0;
		end
		case ( circle_cikl )
			0: begin
					x <= 0;
					y <= radius;
					H <= 1 - radius;
					circle_cikl <= 2;
				end
			1:	begin
					if ( x > y ) begin 
						circle_cikl <= 0;
						busy 			<= 0;
					end
					else begin
						if ( H[10] == 1 ) begin
							H <= H + 2 * x + 3;
							x <= x + 1;							
						end
						else begin
							H <= H + 2 * ( x - y ) + 5;
							x <= x + 1 ;
							y <= y - 1;
						end
					end
					circle_cikl <= circle_cikl + 1;
				end
			2: begin //0
					if ( pixel_ready == 1 ) begin
						{ carry_x, x_out } <= x + center_x;	{ carry_y, y_out } <= center_y - y;
						plot  <= deg[0];
						circle_cikl <= circle_cikl + 1;
					end
				end
			3: begin //1
					if ( pixel_ready == 1 ) begin
						{ carry_x, x_out } <= y + center_x;	{ carry_y, y_out } <= center_y - x;
						plot  <= deg[1];
						circle_cikl <= circle_cikl + 1;
					end
				end
			4: begin //2
					if ( pixel_ready == 1 ) begin
						{ carry_x, x_out } <= y + center_x;	{ carry_y, y_out } <= x + center_y;
						plot  <= deg[2];
						circle_cikl <= circle_cikl + 1;
					end
				end
			5: begin //3
					if ( pixel_ready == 1 ) begin
						{ carry_x, x_out } <= x + center_x;	{ carry_y, y_out } <= y + center_y;
						plot  <= deg[3];
						circle_cikl <= circle_cikl + 1;
					end
				end
			6: begin //4
					if ( pixel_ready == 1 ) begin
						{ carry_x, x_out } <= center_x - x;	{ carry_y, y_out } <= y + center_y;
						plot  <= deg[4];
						circle_cikl <= circle_cikl + 1;
					end
				end
			7: begin //5
					if ( pixel_ready == 1 ) begin
						{ carry_x, x_out } <= center_x - y;	{ carry_y, y_out } <= x + center_y;
						plot  <= deg[5];
						circle_cikl <= circle_cikl + 1;
					end
				end
			8: begin //6
					if ( pixel_ready == 1 ) begin
						{ carry_x, x_out } <= center_x - y;	{ carry_y, y_out } <= center_y - x;
						plot  <= deg[6];
						circle_cikl <= circle_cikl + 1;
					end
				end
			9: begin //7
					if ( pixel_ready == 1 ) begin
						{ carry_x, x_out } <= center_x - x;	{ carry_y, y_out } <= center_y - y;
						plot  <= deg[7];
						circle_cikl <= 1;
					end
				end
		endcase
	end 


end

endmodule
