/*
-------------------------------------------------------------------------------
-- Title      : Ten bit Johnson counter with asynchronous reset
-- Project    : 
-------------------------------------------------------------------------------
-- File       : jcnt2.v
-- Author     : Rick Ballantyne rickb@Xilinx.com>
-- Company    : Xilinx Inc
-- Created    : 2001/03/15
-- Last update: 2001/03/15
-- Copyright  : (c) Xilinx Inc 1999, 2000
-------------------------------------------------------------------------------
-- Uses       : 
-------------------------------------------------------------------------------
-- Used by    : onewire_master.v
-------------------------------------------------------------------------------

-- Description: Ten bit Johnson counter with asynchronous reset
-------------------------------------------------------------------------------
-- Revisions  :
-- Date        Version  Author  		Description
-- 2001/03/15  1.0      Ballantyne    	Conversion from VHDL
-------------------------------------------------------------------------------
*/


module JCNT2 (clk,reset,en,q);
input clk;
input reset;
input en;
output [9:0] q;
reg [9:0] q;

always @ (posedge clk or posedge reset) begin
	if (reset) begin
		q[9:0] <= 10'h000;
		end
	else if (en) begin
		q[9:1] <= q[9:0];
		q[0]   <= !q[9];
		end
	end

endmodule

