/*
-------------------------------------------------------------------------------
-- Title      :  Circular Shift Register with synchronous reset
-- Project    : 
-------------------------------------------------------------------------------
-- File       : sr1.v
-- Author     : Rick Ballantyne rickb@Xilinx.com>
-- Company    : Xilinx Inc
-- Created    : 2001/03/15
-- Last update: 2001/03/15
-- Copyright  : (c) Xilinx Inc 1999, 2000
-------------------------------------------------------------------------------
-- Uses       : 
-------------------------------------------------------------------------------
-- Used by    : onewire_master.v
-------------------------------------------------------------------------------

-- Description: Circular Shift Register with synchronous reset
-------------------------------------------------------------------------------
-- Revisions  :
-- Date        Version  Author  		Description
-- 2001/03/15  1.0      Ballantyne    	Conversion from VHDL
-------------------------------------------------------------------------------
*/
module SR1 (clk,reset,en,q);


input clk;
input reset; 	// synchronous reset
input en;
output [7:0] q;

reg [7:0] q;


always @ (posedge clk) begin
	if (reset) begin
		q[7:0] <=8'h01;
		end
	else if (en) begin
		q[7:1] <= q[6:0];
		q[0]	<= q[7];
		end
	end



endmodule

