		`timescale 1ns / 1ps
	//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    10:11:33 04/03/2011 
// Design Name: 
// Module Name:    Pixel_point_plot 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module Pixel_point_plot( clk,               			//  1 bit input
								 plot_stop,						//  1 bit input
								 cpu_plot_start,    			//  1 bit input
								 cpu_point_start,   			//  1 bit input
								 line_draw_plot_start,		//  1 bit input
								 block_plot_start,			//  1 bit input
								 block_point_start,			//  1 bit input
								 ext_x,				  			//  9 bit input
								 ext_y,				  			//  7 bit input
								 ext_layer_select,  			//  3 bit input
								 ext_pixel_bp,		  			//  1 bit input
								 ext_plot_pixel_bright,		//  2 bit input
 								 ext_plot_pixel_attr,		//  1 bit input
								 sprite_attr_write_en,		//  1 bit input
								 line_draw_x,					//  9 bit input
								 line_draw_y,					//  8 bit input
								 layer0_start_addr, 			// 16 bit input
								 layer1_start_addr, 			// 16 bit input
								 layer2_start_addr, 			// 16 bit input
								 layer3_start_addr, 			// 16 bit input
								 layerx_start_addr, 			// 16 bit input
								 sprite0_width,	  			//  6 bit input
								 sprite0_height,	  			//  7 bit input
								 sprite1_width,	  			//  6 bit input
								 sprite1_height,	  			//  7 bit input
								 sprite2_width,	  			//  6 bit input
								 sprite2_height,	  			//  7 bit input
								 block_x_in,					//  9 bit input
								 block_y_in,					//  7 bit input
								 block_pixel_bp,				//  1 bit input
								 block_plot_pixel_bright,	//	 2 bit input
								 block_layer_select,			//  3 bit input
								 ram_ready,						//  1 bit input
								 pixel_read_data,				//  8 bit input
								 pixel_write_mode,			//  4 bit input
								 circle_x,						//  9 bit input
								 circle_y,						//  8 bit input
								 circle_plot_start,			//  1 bit input
								 pixel_dashed_pattern,			//  1 bit input

								 read_mem_req,					//  1 bit output
								 write_mem_req,				//  1 bit output
								 bram_read_mem_req,			//  1 bit output
								 bram_write_mem_req,			//  1 bit output
								 pixel_addr,					// 17 bit output
								 point_pixel_bright,			//  2 bit output
								 pixel_point_attr,			//  1 bit output
								 pixel_write_data,			//  8 bit output
								 plot_ready,					//  1 bit output
								 ready,							//  1 bit output
								 x,								//  9 bit output
								 y									//  8 bit output
    );

input 			clk;
input				plot_stop;					//  1 bit input
input				cpu_plot_start;    		//  1 bit input
input				cpu_point_start;   		//  1 bit input
input				line_draw_plot_start;	//  1 bit input
input				block_plot_start;			//  1 bit input
input				block_point_start;		//  1 bit input
input	 [8:0]   ext_x; 				 		//  9 bit input
input	 [7:0]   ext_y; 				 		//  8 bit input
input	 [2:0]   ext_layer_select;   		//  3 bit input
input			   ext_pixel_bp;		 		//  1 bit input
input	 [1:0]   ext_plot_pixel_bright; 	//  2 bit input
input				ext_plot_pixel_attr;		//  1 bit input
input  [8:0]	line_draw_x;				//  9 bit input
input  [7:0]	line_draw_y;				//  8 bit input
input	[15:0]   layer0_start_addr; 		// 16 bit input
input	[15:0]   layer1_start_addr; 		// 16 bit input
input	[15:0]   layer2_start_addr; 		// 16 bit input
input	[15:0]   layer3_start_addr; 		// 16 bit input
input	[15:0]   layerx_start_addr; 		// 16 bit input
input	 [6:0]   sprite0_width;	    		//  7 bit input
input	 [7:0]   sprite0_height;    		//  8 bit input
input	 [6:0]   sprite1_width;	    		//  7 bit input
input	 [7:0]   sprite1_height;    		//  8 bit input
input	 [6:0]   sprite2_width;	    		//  7 bit input
input	 [7:0]   sprite2_height;    		//  8 bit input
input  [8:0]	block_x_in;					//  9 bit input
input  [7:0]	block_y_in;					//  7 bit input
input 			block_pixel_bp;			//  1 bit input
input  [1:0]	block_plot_pixel_bright;//  2 bit input
input	 [2:0]	block_layer_select;		//  3 bit input

input				ram_ready;  				//  1 bit input 
input	 [7:0]	pixel_read_data;			//  8 bit input
input	 [3:0]	pixel_write_mode;			//  8 bit input
														// 0 = Normal
														// 1 = Overwrite
														// 2 = OR
														// 3 = XOR
														// 4 = AND
														// 5 = INVERZ
														// 6 = Bright DEC
														// 7 = Bright INC
input				sprite_attr_write_en;		// 0=tiltva, 1=engedelyezve
input [8:0]	   circle_x;						//  9 bit input
input	[7:0]		circle_y;						//  8 bit input
input				circle_plot_start;			//  1 bit input
input				pixel_dashed_pattern;		// Szaggatott vonal eseten a minta bitet tartalmazza



output  			read_mem_req;		  		//  1 bit output
reg  				read_mem_req		 = 0;	
output			write_mem_req;		 		//  1 bit output
reg				write_mem_req		 = 0;	
output  		   bram_read_mem_req;	 	//  1 bit output
reg  		   	bram_read_mem_req	 = 0; 
output			bram_write_mem_req; 		//  1 bit output
reg				bram_write_mem_req = 0;	
output [16:0]	pixel_addr;			 		// 17 bit output
reg [16:0]		pixel_addr			 = 0;	
output  [1:0]  point_pixel_bright;		//  2 bit output
reg  	  [1:0]	point_pixel_bright = 0;
output			pixel_point_attr;			//  1 bit output
reg				pixel_point_attr 	 = 0;
output  [7:0]	pixel_write_data;	  		//  8 bit output
reg     [7:0]	pixel_write_data	 = 0; 
output			plot_ready;					//  1 bit output
output			ready;						//  1 bit output
output  [8:0]	x;
reg 	  [8:0]	x						   	= 0;
output  [7:0]	y;
reg 	  [7:0]	y								= 0;




// Belso regiszterek

reg [15:0]	max_plot_ct					= 0;
reg			plot_start					= 0;
reg			point_start					= 0;
reg [2:0]	layer_select				= 0;
reg 			pixel_bp						= 0;
reg [1:0]   plot_pixel_bright			= 0;
reg [8:0]	x_max							= 320;
reg [7:0]	y_max							= 240;
reg [6:0]   sprite0_w					= 0;	    		
reg [7:0]   sprite0_h					= 0;    		
reg [6:0]   sprite1_w					= 0;	    		
reg [7:0]   sprite1_h					= 0;    		
reg [6:0]   sprite2_w					= 0;	    		
reg [7:0]   sprite2_h					= 0;    		
reg [3:0]	pixel_cikl					= 0;


parameter sprite0_addr = 5'b01010; // 5'b00011;
parameter sprite1_addr = 5'b01011; // 5'b00100;
parameter sprite2_addr = 5'b01100; // 5'b00101;

assign plot_ready = !plot_start;

assign ready = !plot_start && 
					!point_start && 
					!cpu_plot_start && 
					!cpu_point_start &&
					!line_draw_plot_start &&
					!circle_plot_start &&
					!block_plot_start &&
					!block_point_start;



	always @ ( posedge clk ) begin 

		if ( ready == 0 ) begin
			sprite0_w <= sprite0_width  + 1;
			sprite0_h <= sprite0_height + 1;
			sprite1_w <= sprite1_width  + 1;
			sprite1_h <= sprite1_height + 1;
			sprite2_w <= sprite2_width  + 1;
			sprite2_h <= sprite2_height + 1;
		end

		/********************\
		* 	POINT/PLOT        *	
		\********************/

		// CPU felol PLOT funkcio keres
		if( cpu_plot_start == 1 ) begin 
			plot_start 			<= 1;
			pixel_cikl 			<= 0;
			x 					 	<= ext_x;
			y 				    	<= ext_y;
			pixel_bp 			<= ext_pixel_bp;
			layer_select		<= ext_layer_select;
			plot_pixel_bright <= ext_plot_pixel_bright;
		end

		// CPU felol POINT funkcio keres
		if( cpu_point_start == 1 ) begin 
			point_start  <= 1;
			pixel_cikl   <= 0;
			x 				 <= ext_x;
			y 				 <= ext_y;
			pixel_bp		 <= ext_pixel_bp;
			layer_select <= ext_layer_select;
		end

		// line_draw felol PLOT funkcio keres
		if( line_draw_plot_start == 1 ) begin 
			//x			  <= line_draw_x_out;
			//y			  <= line_draw_y_out;
			if ( plot_stop == 0 ) plot_start	<= 1;
			pixel_cikl 			<= 0;
			x 					 	<= line_draw_x;
			y 				    	<= line_draw_y;
			pixel_bp 			<= ext_pixel_bp;
			layer_select		<= ext_layer_select;
			plot_pixel_bright <= ext_plot_pixel_bright;
		end

		// circle modul felol PLOT funkcio keres
		if ( circle_plot_start == 1 ) begin
			if ( plot_stop == 0 ) plot_start <= 1;
			pixel_cikl 			<= 0;
			x 					 	<= circle_x;
			y 				    	<= circle_y;
			pixel_bp 			<= ext_pixel_bp;
			layer_select		<= ext_layer_select;
			plot_pixel_bright <= ext_plot_pixel_bright;			
		end

		// block modul PLOT funkcio keres
		if( block_plot_start == 1 ) begin 
			plot_start 			<= 1;
			x		  				<= block_x_in;
			y		  				<= block_y_in;
			pixel_bp			 	<= block_pixel_bp;
			plot_pixel_bright <= block_plot_pixel_bright;
			layer_select		<= block_layer_select;
		end

		// block modul POINT funkcio keres
		if( block_point_start == 1 ) begin 
			point_start 	<= 1;
			x		  			<= block_x_in;
			y		  			<= block_y_in;
			pixel_bp			<= block_pixel_bp;
			layer_select	<= block_layer_select;
		end	


		
	
		read_mem_req		 <= 0;
		write_mem_req		 <= 0;
		bram_read_mem_req	 <= 0;	
		bram_write_mem_req <= 0;		
	
	
		if ( plot_start == 1 || point_start == 1 ) begin
			case ( pixel_cikl )
				0: begin
						// Az adott layer bit/pixel felbontasanak megfeleloen a pixel-t
						// tartalmazo byte cimenek meghatarozasa
						x_max <= 320;
						y_max <= 240;
						if ( pixel_bp == 0 ) begin
							if ( layer_select == 0 ) pixel_addr = { layer0_start_addr,1'b0 } + ( y * 40 ) + ( x / 8 );
							if ( layer_select == 1 ) pixel_addr = { layer1_start_addr,1'b0 } + ( y * 40 ) + ( x / 8 );
							if ( layer_select == 2 ) pixel_addr = { layer2_start_addr,1'b0 } + ( y * 40 ) + ( x / 8 );
							if ( layer_select == 3 ) pixel_addr = { layer3_start_addr,1'b0 } + ( y * 40 ) + ( x / 8 );
							if ( layer_select == 4 ) pixel_addr = { layerx_start_addr,1'b0 } + ( y * 40 ) + ( x / 8 );
						end
						else begin
							if ( layer_select == 0 ) pixel_addr = { layer0_start_addr,1'b0 } + ( y * 80 ) + ( x / 4 );
							if ( layer_select == 1 ) pixel_addr = { layer1_start_addr,1'b0 } + ( y * 80 ) + ( x / 4 );
							if ( layer_select == 2 ) pixel_addr = { layer2_start_addr,1'b0 } + ( y * 80 ) + ( x / 4 );
							if ( layer_select == 3 ) pixel_addr = { layer3_start_addr,1'b0 } + ( y * 80 ) + ( x / 4 );
							if ( layer_select == 4 ) pixel_addr = { layerx_start_addr,1'b0 } + ( y * 80 ) + ( x / 4 );
							if ( layer_select == 5 ) begin 
								pixel_addr[10:0]  = ( y * sprite0_w )  + ( x / 4 );
								pixel_addr[16:11] = sprite0_addr;
								x_max <= sprite0_w * 4;
								y_max <= sprite0_h;
							end
							if ( layer_select == 6 ) begin 
								pixel_addr[10:0]  = ( y * sprite1_w )  + ( x / 4 );
								pixel_addr[16:11] = sprite1_addr;
								x_max <= sprite1_w * 4;
								y_max <= sprite1_h;
							end
							if ( layer_select == 7 ) begin 
								pixel_addr[10:0]  = ( y * sprite2_w )  + ( x / 4 );
								pixel_addr[16:11] = sprite2_addr;
								x_max <= sprite2_w * 4;
								y_max <= sprite2_h;
							end
						end
						// A szaggatott vonal eseten ha nem kell rajzolni, akkor nem csinal semmit
						if ( pixel_dashed_pattern == 1 ) begin
							pixel_cikl	<= pixel_cikl + 1; 
						end
						else begin
							plot_start 	<= 0;
							point_start	<= 0;
						end
						
						pixel_point_attr <= 0;
					end
				1: begin 
						if ( x < x_max && y < y_max ) begin
							// PLOT vagy POINT funkcional is olvasassal kezd mert 
							// 1 byte-ban tobb pixel van
							if ( layer_select < 5 ) read_mem_req <= 1; else bram_read_mem_req <= 1;
							pixel_cikl <= pixel_cikl + 1; 
						end
						else begin
							// Ha a koordinatak a kirajzolhato teruleten kivul vannak,
							// akkor nem csinal semmit
							plot_start 	<= 0;
							point_start	<= 0;
							pixel_cikl  <= 0;
						end
					end
				2: begin 
						if ( ram_ready == 1 ) begin
							// PLOT vagy POINT funkcionak megfelelo folytatas
							if ( point_start == 1 ) begin 
								// POINT funkcio
								pixel_cikl <= 5;
							end
							else begin
								// PLOT funkcio
								pixel_write_data <= pixel_read_data;
								pixel_cikl 		  <= pixel_cikl + 1; 
							end
						end
					end
				3: begin // PLOT
						if ( pixel_bp == 0 ) begin
							case ( pixel_write_mode[3:0] )
								0: // Ha az irando pont fenyesebb, akkor felulirja a regit
									if ( pixel_write_data[~x[2:0]] <= plot_pixel_bright[0] ) pixel_write_data[~x[2:0]] <= plot_pixel_bright[0];
								1: // PLOT Overwrite mode
									pixel_write_data[~x[2:0]] <= plot_pixel_bright[0];	
								2: // OR
									pixel_write_data[~x[2:0]] <= pixel_write_data[~x[2:0]] | plot_pixel_bright[0];	
								3: // XOR
									pixel_write_data[~x[2:0]] <= pixel_write_data[~x[2:0]] ^ plot_pixel_bright[0];	
								4: // AND
									pixel_write_data[~x[2:0]] <= pixel_write_data[~x[2:0]] & plot_pixel_bright[0];	
								5: // INVERZ
									pixel_write_data[~x[2:0]] <= ~pixel_write_data[~x[2:0]];
								6: // Bright DEC
									pixel_write_data[~x[2:0]] <= pixel_write_data[~x[2:0]] - 1;
								7: // Bright INC
									pixel_write_data[~x[2:0]] <= pixel_write_data[~x[2:0]] + 1;
							endcase
						end
						else begin
							case ( pixel_write_mode[3:0] )
								0: begin // Ha az irando pont fenyesebb, akkor felulirja a regit
										case ( x[1:0] )
											0: if ( pixel_write_data[7:6] <= plot_pixel_bright[1:0] ) pixel_write_data[7:6] <= plot_pixel_bright[1:0];
											1: if ( pixel_write_data[5:4] <= plot_pixel_bright[1:0] ) pixel_write_data[5:4] <= plot_pixel_bright[1:0];
											2: if ( pixel_write_data[3:2] <= plot_pixel_bright[1:0] ) pixel_write_data[3:2] <= plot_pixel_bright[1:0];
											3: if ( pixel_write_data[1:0] <= plot_pixel_bright[1:0] ) pixel_write_data[1:0] <= plot_pixel_bright[1:0];
										endcase
									end
								1: begin // PLOT Overwrite mode
										case ( x[1:0] )
											0: pixel_write_data[7:6] <= plot_pixel_bright[1:0];
											1: pixel_write_data[5:4] <= plot_pixel_bright[1:0];
											2: pixel_write_data[3:2] <= plot_pixel_bright[1:0];
											3: pixel_write_data[1:0] <= plot_pixel_bright[1:0];
										endcase
									end
								2: begin // OR
										case ( x[1:0] )
											0: pixel_write_data[7:6] <= pixel_write_data[7:6] | plot_pixel_bright[1:0];
											1: pixel_write_data[5:4] <= pixel_write_data[5:4] | plot_pixel_bright[1:0];
											2: pixel_write_data[3:2] <= pixel_write_data[3:2] | plot_pixel_bright[1:0];
											3: pixel_write_data[1:0] <= pixel_write_data[1:0] | plot_pixel_bright[1:0];
										endcase
									end
								3: begin // XOR
										case ( x[1:0] )
											0: pixel_write_data[7:6] <= pixel_write_data[7:6] ^ plot_pixel_bright[1:0];
											1: pixel_write_data[5:4] <= pixel_write_data[5:4] ^ plot_pixel_bright[1:0];
											2: pixel_write_data[3:2] <= pixel_write_data[3:2] ^ plot_pixel_bright[1:0];
											3: pixel_write_data[1:0] <= pixel_write_data[1:0] ^ plot_pixel_bright[1:0];
										endcase
									end
								4: begin // AND
										case ( x[1:0] )
											0: pixel_write_data[7:6] <= pixel_write_data[7:6] & plot_pixel_bright[1:0];
											1: pixel_write_data[5:4] <= pixel_write_data[5:4] & plot_pixel_bright[1:0];
											2: pixel_write_data[3:2] <= pixel_write_data[3:2] & plot_pixel_bright[1:0];
											3: pixel_write_data[1:0] <= pixel_write_data[1:0] & plot_pixel_bright[1:0];
										endcase
									end
								5: begin // INVERZ
										case ( x[1:0] )
											0: pixel_write_data[7:6] <= ~pixel_write_data[7:6];
											1: pixel_write_data[5:4] <= ~pixel_write_data[5:4];
											2: pixel_write_data[3:2] <= ~pixel_write_data[3:2];
											3: pixel_write_data[1:0] <= ~pixel_write_data[1:0];
										endcase
									end
								6: begin // Bright DEC
										case ( x[1:0] )
											0: pixel_write_data[7:6] <= pixel_write_data[7:6] - 1;
											1: pixel_write_data[5:4] <= pixel_write_data[5:4] - 1;
											2: pixel_write_data[3:2] <= pixel_write_data[3:2] - 1;
											3: pixel_write_data[1:0] <= pixel_write_data[1:0] - 1 ;
										endcase
									end
								7: begin // Bright INC
										case ( x[1:0] )
											0: pixel_write_data[7:6] <= pixel_write_data[7:6] + 1;
											1: pixel_write_data[5:4] <= pixel_write_data[5:4] + 1;
											2: pixel_write_data[3:2] <= pixel_write_data[3:2] + 1;
											3: pixel_write_data[1:0] <= pixel_write_data[1:0] + 1 ;
										endcase
									end
							endcase
						end
						
						if ( layer_select < 5 ) write_mem_req <= 1; else bram_write_mem_req <= 1;
						pixel_cikl <= pixel_cikl + 1;
					end
				4: begin
						if ( ram_ready == 1 ) begin
							if ( layer_select < 5 ) begin
								plot_start 	<= 0;
								point_start	<= 0;
								pixel_cikl 	<= 0;
							end
							else begin
								pixel_cikl <= 6;
							end
						end
					end
				
				5: begin // POINT
						if ( pixel_bp == 0 ) begin
							point_pixel_bright[1:0] <= { 1'b0, pixel_read_data[~x[2:0]] };
						end
						else begin
							case ( x[1:0] )
								0: point_pixel_bright[1:0] <= pixel_read_data[7:6]; 
								1: point_pixel_bright[1:0] <= pixel_read_data[5:4]; 
								2: point_pixel_bright[1:0] <= pixel_read_data[3:2]; 
								3: point_pixel_bright[1:0] <= pixel_read_data[1:0]; 
							endcase
						end
						if ( layer_select < 5 ) begin 
							plot_start			<= 0;
							point_start 		<= 0;
							pixel_cikl 			<= 0;
						end
						else begin
							pixel_cikl <= 6;
						end
					end
				
				6: begin // sprite attributum iras olvasas
						pixel_addr[10:0]   = 1332;
						sprite0_w			<= sprite0_w / 2;
						pixel_cikl			<= pixel_cikl + 1;
					end
				
				7: begin
						pixel_addr[10:0]   = pixel_addr[10:0] + ( y * sprite0_w ) + ( x / 8 );
						bram_read_mem_req <= 1;
						pixel_cikl			<= pixel_cikl + 1;
					end

				8: begin
						if ( ram_ready == 1 ) begin
							if ( point_start == 1 ) begin
								// Attributum olvasas
								pixel_point_attr 	<= pixel_read_data[ ~x[2:0] ];
								plot_start			<= 0;
								point_start 		<= 0;
								pixel_cikl 			<= 0;
							end
							else begin
								pixel_cikl <= pixel_cikl + 1;
							end
						end
					end
					
				9: begin
						// Attributum iras
						if ( sprite_attr_write_en == 1 ) begin 
							pixel_write_data 				 <= pixel_read_data;
							pixel_write_data[ ~x[2:0] ] <= ext_plot_pixel_attr;
							bram_write_mem_req 			 <= 1;
							pixel_cikl		  				 <= pixel_cikl + 1;
						end
						else begin
							plot_start			<= 0;
							point_start 		<= 0;
							pixel_cikl 			<= 0;
						end
					end

			  10: begin
						if ( ram_ready == 1 ) begin
							plot_start	<= 0;
							point_start <= 0;
							pixel_cikl 	<= 0;
						end
					end
				
			endcase
		end
	
	end

endmodule
