wire	[7:0]		s_data_out0;
wire	[7:0]		s_data_out1;
wire	[7:0]		s_data_out2;
wire	[7:0]		s_data_out3;
wire	[7:0]		s_data_out4;
wire	[7:0]		s_data_out5;
wire	[7:0]		s_data_out6;
wire	[7:0]		s_data_out7;
wire	[7:0]		s_data_out8;
wire	[7:0]		s_data_out9;

wire	[9:0]		s_ram_en;

wire	[9:0]		store_en;
wire	[12:0]	store_addr;
wire	[31:0]	store_write_data;
wire				store_clk;

assign store_en[0]  = ( store_addr[12:9] == 0 ) ? 1 : 0;
assign store_en[1]  = ( store_addr[12:9] == 1 ) ? 1 : 0;
assign store_en[2]  = ( store_addr[12:9] == 2 ) ? 1 : 0;
assign store_en[3]  = ( store_addr[12:9] == 3 ) ? 1 : 0;
assign store_en[4]  = ( store_addr[12:9] == 4 ) ? 1 : 0;
assign store_en[5]  = ( store_addr[12:9] == 5 ) ? 1 : 0;
assign store_en[6]  = ( store_addr[12:9] == 6 ) ? 1 : 0;
assign store_en[7]  = ( store_addr[12:9] == 7 ) ? 1 : 0;
assign store_en[8]  = ( store_addr[12:9] == 8 ) ? 1 : 0;
assign store_en[9]  = ( store_addr[12:9] == 9 ) ? 1 : 0;



RAMB16_S9_S36 Scope_RAM0_inst	(.DOA 	( s_data_out0 ),		// 8 bit data out CPU fele
										 .DOB 	(), 							// ****** 32 bit-es olvasas nem kell
										 .DOPA 	(), 							// 1 bit paritas nem kell
										 .DOPB 	(), 							// ****** 1 bit paritas nem kell
										 .ADDRA 	( bram_addr[10:0] ),		// 11 bit addr CPU felol
										 .ADDRB 	( store_addr[8:0] ), 	// ****** 9 bit addr A/D felol
										 .CLKA 	( bram_clk ), 				// 1 bit CPU clk
										 .CLKB 	( store_clk ),				// ****** 1 bit clk A/D felol
										 .DIA 	( bram_write_data ), 	// 8 bit data in CPU felol
										 .DIB 	( store_write_data ),	// ****** 32 bit data in A/D felol
										 .DIPA 	(0), 							// 1 bit paritas nem kell
										 .DIPB 	(0), 							// ****** 1 bit paritas nem kell
										 .ENA 	( s_ram_en[0] ), 	// 1 bit chip enable CPU felol
										 .ENB 	( store_en[0] ), 			// ****** 1 bit chip enable A/D felol
										 .SSRA 	(0), 
										 .SSRB 	(0), 
										 .WEA 	( bram_we), 				// 1 bit write enable CPU felol
										 .WEB 	(1) );						// ****** 1 bit write enable A/D felol
  

RAMB16_S9_S36 Scope_RAM1_inst	(.DOA 	( s_data_out1 ),		// 8 bit data out CPU fele
										 .DOB 	(), 							// 32 bit-es olvasas nem kell
										 .DOPA 	(), 							// 1 bit paritas nem kell
										 .DOPB 	(), 							// 1 bit paritas nem kell
										 .ADDRA 	( bram_addr[10:0] ),		// 11 bit addr CPU felol
										 .ADDRB 	( store_addr[8:0] ), 	// 9 bit addr A/D felol
										 .CLKA 	( bram_clk ), 				// 1 bit CPU clk
										 .CLKB 	( store_clk ),				// 1 bit clk A/D felol
										 .DIA 	( bram_write_data ), 	// 8 bit data in CPU felol
										 .DIB 	( store_write_data ),	// 32 bit data in A/D felol
										 .DIPA 	(0), 							// 1 bit paritas nem kell
										 .DIPB 	(0), 							// 1 bit paritas nem kell
										 .ENA 	( s_ram_en[1] ), 	// 1 bit chip enable CPU felol
										 .ENB 	( store_en[1] ), 			// 1 bit chip enable A/D felol
										 .SSRA 	(0), 
										 .SSRB 	(0), 
										 .WEA 	( bram_we), 				// 1 bit write enable CPU felol
										 .WEB 	(1) );						// ****** 1 bit write enable A/D felol


RAMB16_S9_S36 Scope_RAM2_inst	(.DOA 	( s_data_out2 ),		// 8 bit data out CPU fele
										 .DOB 	(), 							// 32 bit-es olvasas nem kell
										 .DOPA 	(), 							// 1 bit paritas nem kell
										 .DOPB 	(), 							// 1 bit paritas nem kell
										 .ADDRA 	( bram_addr[10:0] ),		// 11 bit addr CPU felol
										 .ADDRB 	( store_addr[8:0] ), 	// 9 bit addr A/D felol
										 .CLKA 	( bram_clk ), 				// 1 bit CPU clk
										 .CLKB 	( store_clk ),				// 1 bit clk A/D felol
										 .DIA 	( bram_write_data ), 	// 8 bit data in CPU felol
										 .DIB 	( store_write_data ),	// 32 bit data in A/D felol
										 .DIPA 	(0), 							// 1 bit paritas nem kell
										 .DIPB 	(0), 							// 1 bit paritas nem kell
										 .ENA 	( s_ram_en[2] ), 	// 1 bit chip enable CPU felol
										 .ENB 	( store_en[2] ), 			// 1 bit chip enable A/D felol
										 .SSRA 	(0), 
										 .SSRB 	(0), 
										 .WEA 	( bram_we), 				// 1 bit write enable CPU felol
										 .WEB 	(1) );						// ****** 1 bit write enable A/D felol


RAMB16_S9_S36 Scope_RAM3_inst	(.DOA 	( s_data_out3 ),		// 8 bit data out CPU fele
										 .DOB 	(), 							// 32 bit-es olvasas nem kell
										 .DOPA 	(), 							// 1 bit paritas nem kell
										 .DOPB 	(), 							// 1 bit paritas nem kell
										 .ADDRA 	( bram_addr[10:0] ),		// 11 bit addr CPU felol
										 .ADDRB 	( store_addr[8:0] ), 	// 9 bit addr A/D felol
										 .CLKA 	( bram_clk ), 				// 1 bit CPU clk
										 .CLKB 	( store_clk ),				// 1 bit clk A/D felol
										 .DIA 	( bram_write_data ), 	// 8 bit data in CPU felol
										 .DIB 	( store_write_data ),	// 32 bit data in A/D felol
										 .DIPA 	(0), 							// 1 bit paritas nem kell
										 .DIPB 	(0), 							// 1 bit paritas nem kell
										 .ENA 	( s_ram_en[3] ), 	// 1 bit chip enable CPU felol
										 .ENB 	( store_en[3] ), 			// 1 bit chip enable A/D felol
										 .SSRA 	(0), 
										 .SSRB 	(0), 
										 .WEA 	( bram_we), 				// 1 bit write enable CPU felol
										 .WEB 	(1) );						// ****** 1 bit write enable A/D felol


RAMB16_S9_S36 Scope_RAM4_inst	(.DOA 	( s_data_out4 ),		// 8 bit data out CPU fele
										 .DOB 	(), 							// 32 bit-es olvasas nem kell
										 .DOPA 	(), 							// 1 bit paritas nem kell
										 .DOPB 	(), 							// 1 bit paritas nem kell
										 .ADDRA 	( bram_addr[10:0] ),		// 11 bit addr CPU felol
										 .ADDRB 	( store_addr[8:0] ), 	// 9 bit addr A/D felol
										 .CLKA 	( bram_clk ), 				// 1 bit CPU clk
										 .CLKB 	( store_clk ),				// 1 bit clk A/D felol
										 .DIA 	( bram_write_data ), 	// 8 bit data in CPU felol
										 .DIB 	( store_write_data ),	// 32 bit data in A/D felol
										 .DIPA 	(0), 							// 1 bit paritas nem kell
										 .DIPB 	(0), 							// 1 bit paritas nem kell
										 .ENA 	( s_ram_en[4] ), 	// 1 bit chip enable CPU felol
										 .ENB 	( store_en[4] ), 			// 1 bit chip enable A/D felol
										 .SSRA 	(0), 
										 .SSRB 	(0), 
										 .WEA 	( bram_we), 				// 1 bit write enable CPU felol
										 .WEB 	(1) );						// ****** 1 bit write enable A/D felol


RAMB16_S9_S36 Scope_RAM5_inst	(.DOA 	( s_data_out5 ),		// 8 bit data out CPU fele
										 .DOB 	(), 							// 32 bit-es olvasas nem kell
										 .DOPA 	(), 							// 1 bit paritas nem kell
										 .DOPB 	(), 							// 1 bit paritas nem kell
										 .ADDRA 	( bram_addr[10:0] ),		// 11 bit addr CPU felol
										 .ADDRB 	( store_addr[8:0] ), 	// 9 bit addr A/D felol
										 .CLKA 	( bram_clk ), 				// 1 bit CPU clk
										 .CLKB 	( store_clk ),				// 1 bit clk A/D felol
										 .DIA 	( bram_write_data ), 	// 8 bit data in CPU felol
										 .DIB 	( store_write_data ),	// 32 bit data in A/D felol
										 .DIPA 	(0), 							// 1 bit paritas nem kell
										 .DIPB 	(0), 							// 1 bit paritas nem kell
										 .ENA 	( s_ram_en[5] ), 	// 1 bit chip enable CPU felol
										 .ENB 	( store_en[5] ), 			// 1 bit chip enable A/D felol
										 .SSRA 	(0), 
										 .SSRB 	(0), 
										 .WEA 	( bram_we), 				// 1 bit write enable CPU felol
										 .WEB 	(1) );						// ****** 1 bit write enable A/D felol


RAMB16_S9_S36 Scope_RAM6_inst	(.DOA 	( s_data_out6 ),		// 8 bit data out CPU fele
										 .DOB 	(), 							// 32 bit-es olvasas nem kell
										 .DOPA 	(), 							// 1 bit paritas nem kell
										 .DOPB 	(), 							// 1 bit paritas nem kell
										 .ADDRA 	( bram_addr[10:0] ),		// 11 bit addr CPU felol
										 .ADDRB 	( store_addr[8:0] ), 	// 9 bit addr A/D felol
										 .CLKA 	( bram_clk ), 				// 1 bit CPU clk
										 .CLKB 	( store_clk ),				// 1 bit clk A/D felol
										 .DIA 	( bram_write_data ), 	// 8 bit data in CPU felol
										 .DIB 	( store_write_data ),	// 32 bit data in A/D felol
										 .DIPA 	(0), 							// 1 bit paritas nem kell
										 .DIPB 	(0), 							// 1 bit paritas nem kell
										 .ENA 	( s_ram_en[6] ), 	// 1 bit chip enable CPU felol
										 .ENB 	( store_en[6] ), 			// 1 bit chip enable A/D felol
										 .SSRA 	(0), 
										 .SSRB 	(0), 
										 .WEA 	( bram_we), 				// 1 bit write enable CPU felol
										 .WEB 	(1) );						// ****** 1 bit write enable A/D felol


RAMB16_S9_S36 Scope_RAM7_inst	(.DOA 	( s_data_out7 ),		// 8 bit data out CPU fele
										 .DOB 	(), 							// 32 bit-es olvasas nem kell
										 .DOPA 	(), 							// 1 bit paritas nem kell
										 .DOPB 	(), 							// 1 bit paritas nem kell
										 .ADDRA 	( bram_addr[10:0] ),		// 11 bit addr CPU felol
										 .ADDRB 	( store_addr[8:0] ), 	// 9 bit addr A/D felol
										 .CLKA 	( bram_clk ), 				// 1 bit CPU clk
										 .CLKB 	( store_clk ),				// 1 bit clk A/D felol
										 .DIA 	( bram_write_data ), 	// 8 bit data in CPU felol
										 .DIB 	( store_write_data ),	// 32 bit data in A/D felol
										 .DIPA 	(0), 							// 1 bit paritas nem kell
										 .DIPB 	(0), 							// 1 bit paritas nem kell
										 .ENA 	( s_ram_en[7] ), 	// 1 bit chip enable CPU felol
										 .ENB 	( store_en[7] ), 			// 1 bit chip enable A/D felol
										 .SSRA 	(0), 
										 .SSRB 	(0), 
										 .WEA 	( bram_we), 				// 1 bit write enable CPU felol
										 .WEB 	(1) );						// ****** 1 bit write enable A/D felol


RAMB16_S9_S36 Scope_RAM8_inst	(.DOA 	( s_data_out8 ),		// 8 bit data out CPU fele
										 .DOB 	(), 							// 32 bit-es olvasas nem kell
										 .DOPA 	(), 							// 1 bit paritas nem kell
										 .DOPB 	(), 							// 1 bit paritas nem kell
										 .ADDRA 	( bram_addr[10:0] ),		// 11 bit addr CPU felol
										 .ADDRB 	( store_addr[8:0] ), 	// 9 bit addr A/D felol
										 .CLKA 	( bram_clk ), 				// 1 bit CPU clk
										 .CLKB 	( store_clk ),				// 1 bit clk A/D felol
										 .DIA 	( bram_write_data ), 	// 8 bit data in CPU felol
										 .DIB 	( store_write_data ),	// 32 bit data in A/D felol
										 .DIPA 	(0), 							// 1 bit paritas nem kell
										 .DIPB 	(0), 							// 1 bit paritas nem kell
										 .ENA 	( s_ram_en[8] ), 	// 1 bit chip enable CPU felol
										 .ENB 	( store_en[8] ), 			// 1 bit chip enable A/D felol
										 .SSRA 	(0), 
										 .SSRB 	(0), 
										 .WEA 	( bram_we), 				// 1 bit write enable CPU felol
										 .WEB 	(1) );						// ****** 1 bit write enable A/D felol


RAMB16_S9_S36 Scope_RAM9_inst	(.DOA 	( s_data_out9 ),		// 8 bit data out CPU fele
										 .DOB 	(), 							// 32 bit-es olvasas nem kell
										 .DOPA 	(), 							// 1 bit paritas nem kell
										 .DOPB 	(), 							// 1 bit paritas nem kell
										 .ADDRA 	( bram_addr[10:0] ),		// 11 bit addr CPU felol
										 .ADDRB 	( store_addr[8:0] ), 	// 9 bit addr A/D felol
										 .CLKA 	( bram_clk ), 				// 1 bit CPU clk
										 .CLKB 	( store_clk ),				// 1 bit clk A/D felol
										 .DIA 	( bram_write_data ), 	// 8 bit data in CPU felol
										 .DIB 	( store_write_data ),	// 32 bit data in A/D felol
										 .DIPA 	(0), 							// 1 bit paritas nem kell
										 .DIPB 	(0), 							// 1 bit paritas nem kell
										 .ENA 	( s_ram_en[9] ), 	// 1 bit chip enable CPU felol
										 .ENB 	( store_en[9] ), 			// 1 bit chip enable A/D felol
										 .SSRA 	(0), 
										 .SSRB 	(0), 
										 .WEA 	( bram_we), 				// 1 bit write enable CPU felol
										 .WEB 	(1) );						// ****** 1 bit write enable A/D felol
  
  
  
  
  