`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    11:00:24 03/20/2011 
// Design Name: 
// Module Name:    block 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module block(
					clk,
					
    );

always@ ( posedge clk ) begin
	if ( block_start == 1 ) begin
		case ( block_cikl )
			0: begin
					block_x_ct <= 0;
					block_y_ct <= 0;
					block_cikl <= block_cikl + 1;
				end
			1:	begin	
					// Forras pont koordinatainak beallitasa
					// carry - be 1 lessz, ha az x vagy az y regiszter
					// szelessegenel nagyobb a kiszamitott koordinata
					{ carry_x, x } <= source_x + block_x_ct;
					{ carry_y, y } <= source_y + block_y_ct;
					block_cikl <= block_cikl + 1;
				end
			2: begin 
					// POINT start
					layer_select <= source_layer;
					pixel_bp		 <= source_layer_bp;
					if ( carry_x == 0 && carry_y == 0 && x < 320 && y < 240 ) begin 
						// Pont adatainak kiolvasasa
						point_start  <= 1;
					end
					else begin 
						// Hibas koordinata eseten 0 a kiolvasott pixel fenyero
						point_pixel_bright <= block_fill_bright;
					end
					if ( block_mode == 1 ) begin 
						// MOVE
						block_cikl <= block_cikl + 1; 
					end
					else begin
						// COPY or FILL
						block_cikl <= 4;
					end
				end
			3:	begin	
					// MOVE modban visszairja a pixelt block_fill_bright ertekkel
					if ( point_start == 0 && plot_start == 0 ) begin
						plot_pixel_bright <= block_fill_bright;
						plot_start			<= 1;
						block_cikl			<= block_cikl + 1;
					end
				end
			4:	begin // COPY or FILL
					// Cel pixel koordinatak beallitasa
					if ( point_start == 0 && plot_start == 0 ) begin
						// carry - be 1 lessz, ha az x vagy az y regiszter
						// szelessegenel nagyobb a kiszamitott koordinata
						{ carry_x, x } <= x1 + block_x_ct;
						{ carry_y, y } <= y1 + block_y_ct;
						if ( block_mode == 2 ) begin 
							// FILL
							plot_pixel_bright <= block_fill_bright;
						end
						else begin
							// COPY
							plot_pixel_bright <= point_pixel_bright;
						end
						block_cikl <= block_cikl + 1;
					end
				end
			5: begin
					if ( carry_x == 0 && carry_y == 0 && x < 320 && y < 240 ) begin 
						// Pont adatainak kiirasa
						plot_start 	 <= 1;
						layer_select <= target_layer;
						pixel_bp		 <= target_layer_bp;
					end
					// Hibas koordinata eseten nem csinal semmit
					block_cikl <= block_cikl + 1;
				end
			6: begin
					if ( plot_start == 0 && point_start == 0 ) begin 
						if ( block_x_ct == block_width && block_y_ct == block_height ) begin
							block_start <= 0;
							block_cikl  <= 0;
						end
						else begin
							if ( block_x_ct == block_width ) begin
								block_x_ct <= 0;
								block_y_ct <= block_y_ct + 1;
							end
							else begin
								block_x_ct <= block_x_ct + 1;
							end
							block_cikl <= 1;
						end
					end
				end
		endcase
	end
end
endmodule
