`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    12:26:47 03/20/2011 
// Design Name: 
// Module Name:    lookup_table 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////

/****************************************************************\
*	                                                              *
*  A 4 x 2 bit-es keppont adatok alapjan a szurke arnyalatoknak  *
*  megfelelo lcd data kimenetet allitja elo.                     *
*	                                                              *
\****************************************************************/
module lookup_table( clk, 
							cp_enable, 
							frame_enable, 
							lcd_grayscale, 
							lcd_out_data 
							);
							
	input				clk;
	input				cp_enable;
	input				frame_enable;
	input	 [7:0]	lcd_grayscale;
	output [3:0]	lcd_out_data;
	reg	 [3:0]	lcd_out_data;


// Belso regiszterek	
	reg  [1:0] 		rnd	 	 	;
	reg  [4:0]		randomize 	;
	reg  [1:0]     frame_ct  	;
	reg  [1:0]		scan_line0	;
	reg  [1:0]		scan_line1	;
	reg  [1:0]		scan_line2	;
	
	
	
	
	always @( posedge clk ) begin
	
		// RND
		case ( randomize ) 
			0:  rnd <= 1;
			1:  rnd <= 2;
			2:  rnd <= 3;
			3:  rnd <= 2;
			4:  rnd <= 3;
			5:  rnd <= 1;
			6:  rnd <= 3;
			7:  rnd <= 1;
			8:  rnd <= 2;
		endcase 
			
		if ( cp_enable == 1 ) begin
			
			if ( randomize == 8 ) randomize <= 0; else randomize <= randomize + 1;
						
			case ( frame_ct )
				1: begin
						if ( rnd == 1 ) begin scan_line0 <= 2; scan_line1 <= 3; scan_line2 <= 1; end
						if ( rnd == 2 ) begin scan_line0 <= 3;	scan_line1 <= 1; scan_line2 <= 2; end
						if ( rnd == 3 ) begin scan_line0 <= 1; scan_line1 <= 2; scan_line2 <= 3; end
					end
				2: begin
						if ( rnd == 1 ) begin scan_line0 <= 3; scan_line1 <= 1; scan_line2 <= 2; end
						if ( rnd == 2 ) begin scan_line0 <= 1; scan_line1 <= 2; scan_line2 <= 3; end
						if ( rnd == 3 ) begin scan_line0 <= 2; scan_line1 <= 3; scan_line2 <= 1; end
					end
				3: begin
						if ( rnd == 1 ) begin scan_line0 <= 1; scan_line1 <= 2; scan_line2 <= 3; end
						if ( rnd == 2 ) begin scan_line0 <= 2; scan_line1 <= 3; scan_line2 <= 1; end
						if ( rnd == 3 ) begin scan_line0 <= 3; scan_line1 <= 1; scan_line2 <= 2; end
					end
			endcase
			
			if ( lcd_grayscale[1:0] >= scan_line0 ) lcd_out_data[0] <= 1; else lcd_out_data[0] <= 0;
			if ( lcd_grayscale[3:2] >= scan_line1 ) lcd_out_data[1] <= 1; else lcd_out_data[1] <= 0;
			if ( lcd_grayscale[5:4] >= scan_line0 ) lcd_out_data[2] <= 1; else lcd_out_data[2] <= 0;
			if ( lcd_grayscale[7:6] >= scan_line2 ) lcd_out_data[3] <= 1; else lcd_out_data[3] <= 0;

		end
		
		
		if ( frame_enable == 1 ) begin 
			if( frame_ct == 3 ) frame_ct <= 1; else frame_ct <= frame_ct + 1;
		end
		
	end
	
	
endmodule


