`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    12:25:06 03/20/2011 
// Design Name: 
// Module Name:    mem_pri_enc 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
/********************************************************************\
*	                                                                  *
*	Priorita encoder a RAM hozzaferesek engedelyezesehez	            *  			 
*	                                                                  *
\********************************************************************/

module mem_prioritas_encoder(
	input_memreq , 	//  11-bit input 
	out, 					//  4 bit output
	mem_mode,			//  1 bit output
	cpu_ready_mode		//  1 bit input ha 1, akkor a CPU iras/olvasas 
							//  alacsonyabb prioritasu mint az LCD terites
  	);
  
  	input [10:0] input_memreq ; 
  	output [3:0] out ;
  	reg 	 [3:0] out ;
	output		 mem_mode;
	reg			 mem_mode;
	input			 cpu_ready_mode;
	
	parameter	read 	= 0;
	parameter	write	= 1;
	
	always @ ( input_memreq or cpu_ready_mode ) begin 
		if 	  ( input_memreq[0] == 1 && cpu_ready_mode == 0 ) begin out = 1; mem_mode = read;  end  // CPU olvasas
		else if ( input_memreq[1] == 1 && cpu_ready_mode == 0 ) begin out = 2; mem_mode = write; end  // CPU iras
		else if ( input_memreq[2] == 1 ) begin out = 3; mem_mode = read;  end  // Text layer olvasas 
		else if ( input_memreq[3] == 1 ) begin out = 4; mem_mode = read;  end  // Ext CGROM olvasas 
		else if ( input_memreq[4] == 1 ) begin out = 5; mem_mode = read;  end  // LCD layer0 olvasas 
		else if ( input_memreq[5] == 1 ) begin out = 6; mem_mode = read;  end  // LCD layer1 olvasas 
		else if ( input_memreq[6] == 1 ) begin out = 7; mem_mode = read;  end  // LCD layer2 olvasas 
		else if ( input_memreq[7] == 1 ) begin out = 8; mem_mode = read;  end  // LCD layer3 olvasas 
		else if ( input_memreq[0] == 1 && cpu_ready_mode == 1 ) begin out = 1; mem_mode = read;  end  // CPU olvasas
		else if ( input_memreq[1] == 1 && cpu_ready_mode == 1 ) begin out = 2; mem_mode = write; end  // CPU iras
		else if ( input_memreq[8] == 1 ) begin out = 9 ; mem_mode = read;   end  // pont olvasas 
		else if ( input_memreq[9] == 1 ) begin out = 10; mem_mode = write;  end  // pont iras 
		else if ( input_memreq[10]== 1 ) begin out = 11; mem_mode = write;  end  // Screen capture byte iras 
		else begin out = 0; mem_mode = read; end
	end
endmodule 


//BRAM_mem_prioritas_encoder PRIENC2(
//												.input_memreq ( bram_mem_req ) ,
//												.out ( bram_mem_req_target ), 			
//												.mem_mode ( bm_mode )		
//											  );
module BRAM_mem_prioritas_encoder(
	input_memreq , 	//  4-bit input 
	out, 					//  3 bit output
	mem_mode			//  1 bit output
  	);

  	input  [3:0] input_memreq ; 
  	output [2:0] out ;
  	reg 	 [2:0] out ;
	output		 mem_mode;
	reg			 mem_mode;

	parameter	read 	= 0;
	parameter	write	= 1;

	always @ ( input_memreq ) begin 
		if 	  ( input_memreq[0] == 1 ) begin out = 1; mem_mode = read;  end  // CPU olvasas
		else if ( input_memreq[1] == 1 ) begin out = 2; mem_mode = write; end  // CPU iras
		else if ( input_memreq[2] == 1 ) begin out = 3; mem_mode = read; end   // pont olvasas
		else if ( input_memreq[3] == 1 ) begin out = 4; mem_mode = write; end  // pont iras
		else begin out = 0; mem_mode = read; end
	end
endmodule 

